using System;
using Dll_CSharp_VSensor;
using System.Collections.Generic;
namespace Demo.HDR
{
    public class Program
    {
        static void Main(string[] args)
        {
            try
            {
                //获取相对路径
                string path = System.IO.Directory.GetCurrentDirectory();
                //实例化设备
                VSensorDLL VSensor = new VSensorDLL();
                //获取设备列表
                List<VSensorCameraInfoCLR> list = new List<VSensorCameraInfoCLR>(20);
                for (int i = 0; i < 20; i++)
                {
                    list.Add(new VSensorCameraInfoCLR());
                }
                int num = 0;
                VSensor.GetDeviceList(ref list, ref num);
                for (int i = 0; i < num; i++)
                {
                    Console.WriteLine("device num {0} : list[{1}] = {2}\n", i, i, list[i].CameraName);
                }
                //连接第一台设备
                int status = VSensor.DeviceConnect(0);
                if (status != 0)
                {
                    Console.WriteLine("connect device failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //设备参数初始化，仅上电时需要进行此操作，初始化需要等待15s
                Console.WriteLine("waiting for parameter init...\n");
                status = VSensor.DeviceParameterInit();
                if (status != 0)
                {
                    Console.WriteLine("parameter init failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //设置专家模式
                status = VSensor.SetUserSettingMode(1);
                if (status != 0)
                {
                    Console.WriteLine("set user setting mode failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //设置自动HDR
                status = VSensor.SetAutoHDR(true, 2, 50);
                if (status != 0)
                {
                    Console.WriteLine("set auto HDR failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                /*
                //设置手动HDR
                status = VSensor.SetHDR(2.0, 10.0, true);
                if (status != 0)
                {
                    Console.WriteLine("set hand HDR failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                */
                //设置为采集模式
                status = VSensor.SetCaptureMode(1);
                if (status != 0)
                {
                    Console.WriteLine("set capture mode failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //单次采集测试
                Console.WriteLine("single restruction ...\n");
                status = VSensor.SingleRestruction(0);
                if (status != 0)
                {
                    Console.WriteLine("single restruction failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //获取当前相机输出分辨率
                int width = 0;
                int height = 0;
                VSensor.GetImageResolution(ref width, ref height);
                VSensorResultCLR result = new VSensorResultCLR(width, height);
                VSensor.GetRestructionResult(0, 0, 1, ref result);
                //保存点云为ply格式
                status = VSensor.Save3DCloud(path + @"\test.ply", result, 0);
                if (status != 0)
                {
                    Console.WriteLine("save 3D points failed, status = {0}\n", status);
                    Console.ReadLine();
                }
                //反初始化设备
                status = VSensor.DeviceUnInit();
                if (status != 0)
                {
                    Console.WriteLine("device release failed, status = {0}\n", status);
                    Console.ReadLine();
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine($"ex:{ex}");
            }
            Console.WriteLine("run success");
            Console.ReadLine();
            Console.ReadKey();
        }
    }
}

